<?php
/**
* @package RSFiles!
* @copyright (C) 2010-2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('JPATH_PLATFORM') or die;
JFormHelper::loadFieldClass('list');

class JFormFieldGroups extends JFormFieldList
{
	public $type = 'Groups';
	
	public function __construct($parent = null) {
		parent::__construct($parent);
	}

	protected function getOptions() {
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);
		$options= array();
		$ignore = $this->element['ignore'] && $this->element['ignore'] == 'true' ? true : false;
		$default= array(JHtml::_('select.option',0,JText::_('COM_RSFILES_EVERYBODY')));
		
		if ($ignore) {
			$default = array(JHtml::_('select.option','-',JText::_('COM_RSFILES_IGNORE')), JHtml::_('select.option',0,JText::_('COM_RSFILES_EVERYBODY')));
		}
		
		// Get the selected users
		$query->clear();
		$query->select($db->qn('IdGroup','value'));
		$query->select($db->qn('GroupName','text'));
		$query->from($db->qn('#__rsfiles_groups'));
		
		$db->setQuery($query);
		if ($groups = $db->loadObjectList()) {
			return array_merge($default,$groups);
		}
		
		return $default;
	}
}