<?php
/**
* @package RSFiles!
* @copyright (C) 2010-2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');
JHtml::_('behavior.keepalive'); ?>

<form method="post" action="<?php echo JRoute::_('index.php?option=com_rsfiles&view=statistics'); ?>" name="adminForm" id="adminForm">

	<?php echo RSFilesAdapterGrid::sidebar(); ?>
		<?php echo JLayoutHelper::render('joomla.searchtools.default', array('view' => $this)); ?>
		<table class="table table-striped">
			<caption id="captionTable" class="sr-only">
				<span id="orderedBy"><?php echo JText::_('JGLOBAL_SORTED_BY'); ?> </span>,
				<span id="filteredBy"><?php echo JText::_('JGLOBAL_FILTERED_BY'); ?></span>
			</caption>
			<thead>
				<th width="1%" class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?>"><?php echo JHtml::_('grid.checkall'); ?></th>
				<th><?php echo JText::_('COM_RSFILES_FILE_PATH'); ?></th>
				<th width="8%" class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?> hidden-phone"><?php echo JText::_('COM_RSFILES_STATISTICS_ADDED_BY'); ?></th>
				<th width="10%" class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?> hidden-phone"><?php echo JText::_('COM_RSFILES_STATISTICS_DATE_ADDED'); ?></th>
				<th width="10%" class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?> hidden-phone"><?php echo JText::_('COM_RSFILES_STATISTICS_DATE_REMOVED'); ?></th>
				<th width="3%" class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?> hidden-phone"><?php echo JText::_('COM_RSFILES_STATISTICS_HITS'); ?></th>
				<th width="3%" class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?> hidden-phone"><?php echo JText::_('COM_RSFILES_STATISTICS_DOWNLOADS'); ?></th>
			</thead>
			<tbody>
				<?php foreach ($this->items as $i => $item) { ?>
					<tr class="row<?php echo $i % 2; ?>">
						<td class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?>">
							<?php echo JHtml::_('grid.id', $i, $item->id); ?>
						</td>
						<td class="nowrap has-context">
							<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&view=statistics&layout=view&id='.$item->id); ?>">
								<?php echo empty($item->IdFile) ? $item->path : $item->FilePath; ?>
							</a>
						</td>
						<td class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?> hidden-phone">
							<?php echo empty($item->name) ? '-' : $item->name; ?>
						</td>
						<td class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?> hidden-phone">
							<?php echo $item->created_date == JFactory::getDbo()->getNullDate() ? '-' : rsfilesHelper::showDate($item->created_date); ?>
						</td>
						<td class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?> hidden-phone">
							<?php echo $item->removed_date == JFactory::getDbo()->getNullDate() ? '-' : rsfilesHelper::showDate($item->removed_date); ?>
						</td>
						<td class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?> hidden-phone">
							<?php echo $item->hits ? $item->hits : '-'; ?>
						</td>
						<td class="<?php echo RSFilesAdapterGrid::styles(array('center')); ?> hidden-phone">
							<?php echo $item->downloads; ?>
						</td>
					</tr>
				<?php } ?>
			</tbody>
			<tfoot>
				<tr>
					<td colspan="7"><?php echo $this->pagination->getListFooter(); ?></td>
				</tr>
			</tfoot>
		</table>
	</div>
	
	<?php echo JHTML::_( 'form.token' ); ?>
	<input type="hidden" name="task" value="" />
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="return" value="<?php echo $this->return; ?>" />
</form>