<?php
/**
* @package RSFiles!
* @copyright (C) 2010-2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' ); ?>

<?php if ($this->params->get('show_page_heading') != 0) { ?>
<div class="page-header">
	<h1><?php echo $this->escape($this->params->get('page_heading')); ?></h1>
</div>
<?php } ?>

<div class="rsfiles-layout" id="rsfiles-layout-j<?php echo rsfilesHelper::isJ4() ? 4 : 3; ?>">

	<?php echo $this->loadTemplate('navbar'); ?>
		
	<?php if (($this->config->show_pagination_position == 0 || $this->config->show_pagination_position == 2) && $this->pagination->pagesTotal > 1) { ?>
	<div class="com-rsfiles-briefcase_navigation w-100 <?php echo !rsfilesHelper::isJ4() ? 'pagination' : ''; ?>">
		<p class="com-rsfiles-briefcase_counter <?php echo RSFilesAdapterGrid::styles(array('counter','pull-right')); ?>">
			<?php echo $this->pagination->getPagesCounter(); ?>
		</p>
		<div class="com-rsfiles-briefcase_pagination">
			<?php echo $this->pagination->getPagesLinks(); ?>
		</div>
	</div>
	<?php } ?>
		
	<?php if ((!$this->maintenance && $this->briefcase_root != $this->config->briefcase_folder) || ($this->maintenance && $this->current != $this->config->briefcase_folder)) { ?>
	<div class="<?php echo RSFilesAdapterGrid::card(); ?> mb-3 mt-3">
		<div class="card-body">
			<div class="<?php echo RSFilesAdapterGrid::row(); ?>">
				<div class="<?php echo RSFilesAdapterGrid::column(8); ?>">
					<?php if ($this->config->show_folder_desc == 1 && !empty($this->fdescription)) echo $this->fdescription; ?>
				</div>
				<div class="<?php echo RSFilesAdapterGrid::column(4); ?>">
					<?php if(($this->maintenance && !empty($this->folder)) || !$this->maintenance) { ?>
					<b class="rsf_briefcase_name"><?php echo JText::_('COM_RSFILES_BRIEFCASE_FILES'); ?></b> <?php echo $this->curentfilesno; ?> / <?php echo $this->maxfilesno; ?> <br />
					<b class="rsf_briefcase_name"><?php echo JText::_('COM_RSFILES_BRIEFCASE_QUOTA'); ?></b> <?php echo $this->currentquota; ?> / <?php echo $this->maxfilessize; ?> Mb
					<?php $percentage = (ceil($this->currentquota/$this->maxfilessize*100) <= 100 ? ceil($this->currentquota/$this->maxfilessize*100) : '100'); ?>
					<?php $class = $percentage >= 90 ? 'progress-danger' : ''; ?>
					<?php $barclass = $percentage >= 90 && rsfilesHelper::isJ4() ? 'bg-danger' : ''; ?>
					<div class="progress <?php echo $class; ?>">
						<div class="<?php echo RSFilesAdapterGrid::styles(array('bar')).' '.$barclass; ?>" style="width: <?php echo $percentage; ?>%;">&nbsp;</div>
					</div>
					<?php } ?>
				</div>
			</div>
		</div>
	</div>
	<?php } ?>
		
	<form action="<?php echo htmlentities(JURI::getInstance(), ENT_COMPAT, 'UTF-8'); ?>" method="post" id="adminForm" name="adminForm">
		
		<?php echo $this->loadTemplate($this->params->get('flayout', 'table')); ?>
		
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="filter_order" value="<?php echo $this->escape($this->listOrder); ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $this->escape($this->listDirn); ?>" />
	</form>
		
	<?php if (($this->config->show_pagination_position == 1 || $this->config->show_pagination_position == 2) && $this->pagination->pagesTotal > 1) { ?>
	<div class="com-rsfiles-briefcase_navigation w-100 <?php echo !rsfilesHelper::isJ4() ? 'pagination' : ''; ?>">
		<p class="com-rsfiles-briefcase_counter <?php echo RSFilesAdapterGrid::styles(array('counter','pull-right')); ?>">
			<?php echo $this->pagination->getPagesCounter(); ?>
		</p>
		<div class="com-rsfiles-briefcase_pagination">
			<?php echo $this->pagination->getPagesLinks(); ?>
		</div>
	</div>
	<?php } ?>
</div>

<?php if ($this->config->modal == 1) echo JHtml::_('bootstrap.renderModal', 'rsfRsfilesModal', array('title' => '', 'bodyHeight' => 70)); ?>