<?php
/**
* @package RSFiles!
* @copyright (C) 2010-2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' ); ?>

<?php if (!empty($this->items)) { ?>
<?php $columns = $this->params->get('cols', 3); ?>
<?php $cols = ceil(12/$columns); ?>
<?php $items = array_chunk($this->items, $columns); ?>

<?php foreach ($items as $chunck) { ?>
<div class="<?php echo RSFilesAdapterGrid::row(); ?> mt-3">
	<?php foreach($chunck as $item) { ?>
		<?php $thumbnail 	= rsfilesHelper::thumbnail($item); ?>
		<?php $fullpath		= $this->dld_fld.$this->ds.urldecode($item->fullpath) ; ?>
		<?php $path			= str_replace($this->config->download_folder.$this->ds, '', $fullpath);  ?>
		<?php $canDownload 	= rsfilesHelper::permissions('CanDownload',$path); ?>
		<?php $canDelete   	= rsfilesHelper::permissions('CanDelete',$path) || (rsfilesHelper::briefcase('deleteown') && $item->IdUser == $this->user->get('id')); ?>
		<?php if (!empty($item->DownloadLimit) && $item->Downloads >= $item->DownloadLimit) $canDownload = false; ?>
		
		<div class="<?php echo RSFilesAdapterGrid::column($cols); ?> d-flex rsfiles-block-item">
			<div class="card text-center flex-fill">
				<div class="card-image">
					<i class="<?php echo $item->type != 'folder' ? $item->icon : 'fa fa-folder'; ?> rsfiles-icon-large"></i>
				</div>
				<div class="card-body">
					<?php if ($item->type != 'folder') { ?>
					<?php $download = rsfilesHelper::downloadlink($item,$item->fullpath); ?>
					<?php if ($canDownload && $this->config->direct_download) { ?>
					<?php if ($download->ismodal) { ?>
					<a class="rsfiles-file <?php echo $thumbnail->class; ?>" href="javascript:void(0)" onclick="rsfiles_show_modal('<?php echo $download->dlink; ?>', '<?php echo JText::_('COM_RSFILES_DOWNLOAD'); ?>', 600)" title="<?php echo $thumbnail->image; ?>">
					<?php } else { ?>
					<a class="rsfiles-file rsfiles-download-link <?php echo $thumbnail->class; ?>" href="<?php echo $download->dlink; ?>" title="<?php echo $thumbnail->image; ?>">
					<?php } ?>
					<?php } else { ?>
					<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&layout=download&path='.rsfilesHelper::encode($item->fullpath).$this->itemid); ?>" class="rsfiles-file <?php echo $thumbnail->class; ?>" title="<?php echo $thumbnail->image; ?>">
					<?php } ?>
					<?php } else { ?>
					<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&folder='.rsfilesHelper::encode($item->fullpath).$this->itemid); ?>" class="<?php echo $thumbnail->class; ?>" title="<?php echo $thumbnail->image; ?>">
					<?php } ?>
						<h5 class="card-title"><?php echo !empty($item->filename) ? $item->filename : $item->name; ?></h5>
					</a>
					
					<div class="clearfix"></div>
					
					<?php if ($item->type != 'folder' && $item->isnew) { ?>
					<span class="badge badge-info bg-info"><?php echo JText::_('COM_RSFILES_NEW'); ?></span>
					<?php } ?>
					
					<?php if ($item->type != 'folder' && $item->popular) { ?>
						<span class="badge badge-success bg-success"><?php echo JText::_('COM_RSFILES_POPULAR'); ?></span>
					<?php } ?>
					
				</div>
				
				<?php if ($item->type != 'folder') { ?>
				<div class="card-footer">					
					<?php if ($canDownload && $this->config->direct_download) { ?>
					<?php if ($download->ismodal) { ?>
					<a class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_DOWNLOAD'); ?>" href="javascript:void(0)" onclick="rsfiles_show_modal('<?php echo $download->dlink; ?>', '<?php echo JText::_('COM_RSFILES_DOWNLOAD'); ?>', 600);">
					<?php } else { ?>
					<a class="hasTooltip rsfiles-download-link" title="<?php echo JText::_('COM_RSFILES_DOWNLOAD'); ?>" href="<?php echo $download->dlink; ?>">
					<?php } ?>
					<?php } else { ?>
					<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&layout=download&path='.rsfilesHelper::encode($item->fullpath).$this->itemid); ?>" class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_DOWNLOAD'); ?>">
					<?php } ?>
						<i class="fa fa-download fa-fw"></i>
					</a>
					
					<?php if ($this->config->show_details) { ?>
					<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&layout=details&path='.rsfilesHelper::encode($item->fullpath).$this->itemid); ?>" class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_DETAILS'); ?>">
						<i class="fa fa-list fa-fw"></i>
					</a>
					<?php } ?>
					
					<?php if ($canDownload) { ?>
						<?php $properties	= rsfilesHelper::previewProperties($item->id, $item->fullpath); ?>
						<?php $extension	= $properties['extension']; ?>
						<?php $size			= $properties['size']; ?>
						
						<?php if (in_array($extension, rsfilesHelper::previewExtensions()) && $item->show_preview) { ?>
						<a href="javascript:void(0)" onclick="rsfiles_show_modal('<?php echo rsfilesHelper::previewURL($extension, JRoute::_('index.php?option=com_rsfiles&layout=preview&tmpl=component&path='.rsfilesHelper::encode($item->fullpath).$this->itemid)); ?>', '<?php echo JText::_('COM_RSFILES_PREVIEW'); ?>', <?php echo $size['height']; ?>, '<?php echo $properties['handler']; ?>');" class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_PREVIEW'); ?>">
							<i class="fa fa-search fa-fw"></i>
						</a>
						<?php } ?>
					<?php } ?>
					
					<?php if ($canDownload && $this->config->show_bookmark && !$item->FileType) { ?>
					<a href="javascript:void(0);" class="hasTooltip" title="<?php echo rsfilesHelper::isBookmarked($item->fullpath) ? JText::_('COM_RSFILES_NAVBAR_FILE_IS_BOOKMARKED') : JText::_('COM_RSFILES_NAVBAR_BOOKMARK_FILE'); ?>" onclick="rsf_bookmark('<?php echo JURI::root(); ?>','<?php echo $this->escape(addslashes(urldecode($item->fullpath))); ?>','<?php echo $this->briefcase ? 1 : 0; ?>','<?php echo $this->app->input->getInt('Itemid',0); ?>', this)">
						<i class="<?php echo rsfilesHelper::isBookmarked($item->fullpath) ? 'fa' : 'far'; ?> fa-bookmark fa-fw"></i>
					</a>
					<?php } ?>
					
					<?php if ($canDelete) { ?>
					<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&task=rsfiles.delete&path='.rsfilesHelper::encode($item->fullpath).$this->itemid); ?>" class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_NAVBAR_DELETE'); ?>" onclick="if (!confirm('<?php echo JText::_('COM_RSFILES_DELETE_FILE_MESSAGE',true); ?>')) return false;">
						<i class="fa fa-trash fa-fw"></i>
					</a>
					<?php } ?>
				</div>
				<?php } else if ($item->type == 'folder') { ?>
				
					<?php if ($canDelete) { ?>
					<div class="card-footer">
						<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&task=rsfiles.delete&folder='.rsfilesHelper::encode($item->fullpath).$this->itemid); ?>" class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_NAVBAR_DELETE'); ?>" onclick="if (!confirm('<?php echo JText::_('COM_RSFILES_DELETE_MESSAGE',true); ?>')) return false;">
							<i class="fa fa-trash fa-fw"></i>
						</a>
					</div>
					<?php } ?>
				<?php } ?>
			</div>
		</div>
	<?php } ?>
</div>
<?php } ?>


<?php } else { ?>
<div class="alert alert-info"><?php echo JText::_('COM_RSFILES_NO_FILES'); ?></div>
<?php } ?>