<?php
/**
* @package RSFiles!
* @copyright (C) 2010-2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' ); 
JHtml::_('behavior.keepalive');
JHtml::_('behavior.formvalidator');
JHtml::_('formbehavior.chosen', '#jform_tags');

$extension	= strtolower(rsfilesHelper::getExt($this->item->FilePath));
$icon	= 'fa fa-file';
$ext	= $this->item->icon ? $this->item->icon : $extension;
			
if (in_array($ext, rsfilesHelper::fileExtensions())) {
	$icon = 'flaticon-'.$ext.'-file';
} 
?>

<script type="text/javascript">
	Joomla.submitbutton = function(task) {
		if (task == 'rsfiles.cancel' || task == 'rsfiles.deletethumb' || task == 'rsfiles.deletepreview' || document.formvalidator.isValid(document.getElementById('adminForm'))) {
			Joomla.submitform(task);
		}
	}
</script>

<div class="rsfiles-layout">
	
	<ul class="<?php echo RSFilesAdapterGrid::styles(array('unstyled', 'inline')); ?>">
		<?php if (!$this->briefcase) { ?>
		<li class="list-inline-item">
			<a class="<?php echo RSFilesAdapterGrid::styles(array('btn')); ?> hasTooltip" title="<?php echo JText::_('COM_RSFILES_NAVBAR_HOME'); ?>" href="<?php echo JRoute::_('index.php?option=com_rsfiles'.$this->itemid); ?>">
				<span class="fa fa-home"></span>
			</a>
		</li>
		<?php } else { ?>
		<li class="list-inline-item">
			<a class="<?php echo RSFilesAdapterGrid::styles(array('btn')); ?> hasTooltip" title="<?php echo JText::_('COM_RSFILES_NAVBAR_BRIEFCASE'); ?>" href="<?php echo JRoute::_('index.php?option=com_rsfiles&layout=briefcase'.$this->itemid); ?>">
				<span class="fa fa-briefcase"></span>
			</a>
		</li>
		<?php } ?>
		<li class="list-inline-item <?php echo RSFilesAdapterGrid::styles(array('pull-right')); ?>">
			<button type="button" class="btn btn-primary" onclick="Joomla.submitbutton('rsfiles.save')"><?php echo JText::_('COM_RSFILES_SAVE'); ?></button> 
			<button type="button" class="btn btn-danger" onclick="Joomla.submitbutton('rsfiles.cancel')"><?php echo JText::_('COM_RSFILES_CANCEL'); ?></button>
		</li>
	</ul>
	
	<form action="<?php echo JRoute::_('index.php?option=com_rsfiles'.$this->itemid,false); ?>" method="post" enctype="multipart/form-data" name="adminForm" id="adminForm" class="form-validate form-vertical">
		
		<?php echo JHtml::_('bootstrap.startTabSet', 'editForm', array('active' => 'details')); ?>
		<?php echo JHtml::_('bootstrap.addTab', 'editForm', 'details', JText::_('COM_RSFILES_FILE_DETAILS')); ?>
				
		<?php if ($this->item->FileType) { ?>
		<div class="<?php echo RSFilesAdapterGrid::row(); ?>">
			<div class="<?php echo RSFilesAdapterGrid::column(12); ?>">
				<?php echo $this->form->renderField('FilePath'); ?>
				<?php echo $this->form->renderField('DownloadName'); ?>
			</div>
		</div>
		<?php } ?>
			
		<div class="<?php echo RSFilesAdapterGrid::row(); ?>">
			<div class="<?php echo RSFilesAdapterGrid::column(6); ?>">
				<?php echo $this->form->renderField('published'); ?>
				<?php echo $this->form->renderField('FileName'); ?>
				
				<div class="control-group">
					<div class="control-label">
						<label><?php echo JText::_('COM_RSFILES_FILE_ICON'); ?></label>
					</div>
					<div class="controls">
						<button type="button" onclick="jQuery('#rsfIcon').modal('show');" class="<?php echo RSFilesAdapterGrid::styles(array('btn')); ?> btn-block hasTooltip" title="<?php echo JText::_('COM_RSFILES_FILE_ICON'); ?>" id="file_icon"><i id="rsfiles-icon" class="<?php echo $icon; ?>"></i></button>
					</div>
				</div>
				
				<?php echo $this->form->renderField('DateAdded'); ?>
				<?php if (!$this->briefcase) echo $this->form->renderField('IdLicense'); ?>
				
				<div class="control-group">
					<div class="control-label">
						<label for="thumb" class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_FILE_THUMB_DESC'); ?>"><?php echo JText::_('COM_RSFILES_FILE_THUMB'); ?></label>
					</div>
					<div class="controls">
					<?php if (empty($this->item->FileThumb) || !file_exists(JPATH_SITE.'/components/com_rsfiles/images/thumbs/files/'.$this->item->FileThumb)) { ?>
						<input type="file" id="thumb" name="thumb" size="50" class="form-control" />
					<?php } else { ?>
						<?php echo JHTML::_('image', JURI::root().'components/com_rsfiles/images/thumbs/files/'.$this->item->FileThumb.'?sid='.rand(), '', array('class' => 'rsf_thumb', 'style' => 'vertical-align: middle')); ?>
						<a href="javascript:void(0);" onclick="Joomla.submitbutton('rsfiles.deletethumb');">
							<i class="fa fa-trash"></i>
						</a>
					<?php } ?>
					</div>
				</div>
				
			</div>
			<div class="<?php echo RSFilesAdapterGrid::column(6); ?>">
				<?php if (!$this->briefcase) echo $this->form->renderField('FileStatistics'); ?>
				<?php echo $this->form->renderField('FileVersion'); ?>
				<?php echo $this->form->renderField('tags'); ?>
				<?php echo $this->form->renderField('publish_down'); ?>
				<?php if (!$this->briefcase) echo $this->form->renderField('DownloadMethod'); ?>
				
				<div class="control-group">
					<div class="control-label">
						<label for="thumb" class="hasTooltip" title="<?php echo JText::sprintf('COM_RSFILES_FILE_PREVIEW_DESC', rsfilesHelper::previewExtensions(true)); ?>"><?php echo JText::_('COM_RSFILES_FILE_PREVIEW'); ?></label>
					</div>
					<div class="controls">
					<?php if (empty($this->item->preview) || !file_exists(JPATH_SITE.'/components/com_rsfiles/images/preview/'.$this->item->preview)) { ?>
						<input type="file" id="preview" name="preview" size="50" class="form-control" /> <br />
						<?php echo RSFilesAdapterGrid::inputGroup('<input type="text" value="200" class="input-mini form-control" size="5" name="resize_width" />', '<span class="input-group-text"><label class="checkbox inline" for="resize"><input type="checkbox" id="resize" name="resize" value="1" /> '.JText::_('COM_RSFILES_FILE_PREVIEW_RESIZE').'</label></span>', 'px'); ?>
					<?php } else { ?>
						<?php $properties = rsfilesHelper::previewProperties($this->item->IdFile); ?>
						<a href="javascript:void(0);" onclick="rsfiles_show_modal('<?php echo JRoute::_('index.php?option=com_rsfiles&task=preview&tmpl=component&id='.$this->item->IdFile,false); ?>','<?php echo JText::_('COM_RSFILES_FILE_PREVIEW'); ?>', '<?php echo $properties['size']['height']; ?>')"><?php echo JText::_('COM_RSFILES_FILE_PREVIEW'); ?></a>
						 / <a href="javascript:void(0);" onclick="Joomla.submitbutton('rsfiles.deletepreview');"><?php echo JText::_('COM_RSFILES_DELETE'); ?></a>
					<?php } ?>
					</div>
				</div>
			</div>
		</div>
		<div class="clearfix"></div>
		<?php echo $this->form->getInput('FileDescription'); ?>
		<div class="clearfix"></div>
			
		<?php echo JHtml::_('bootstrap.endTab'); ?>
		<?php echo JHtml::_('bootstrap.addTab', 'editForm', 'meta', JText::_('COM_RSFILES_FILE_METADATA')); ?>
		<div class="<?php echo RSFilesAdapterGrid::row(); ?>">
			<div class="<?php echo RSFilesAdapterGrid::column(12); ?>">
				<?php echo $this->form->renderField('metatitle'); ?>
				<?php echo $this->form->renderField('metadescription'); ?>
				<?php echo $this->form->renderField('metakeywords'); ?>
			</div>
		</div>
		<?php echo JHtml::_('bootstrap.endTab'); ?>
		<?php echo JHtml::_('bootstrap.endTabSet'); ?>
		
		<?php if ($this->config->consent) { ?>
		<div class="control-group mt-3">
			<div class="controls">
				<label class="checkbox" for="consent">
					<input type="checkbox" id="consent" class="required" name="consent" value="1" /> 
					<?php echo JText::_('COM_RSFILES_CONSENT'); ?>
				</label>
			</div>
		</div>
		<?php } ?>
		
		<?php echo JHTML::_( 'form.token' ); ?>
		<input type="hidden" name="task" value="" />
		<?php echo $this->form->getInput('IdFile'); ?>
		<?php echo $this->form->getInput('FileType'); ?>
		<?php echo $this->form->getInput('icon'); ?>
		<input type="hidden" name="from" value="<?php echo $this->escape($this->app->input->get('from'));?>" />
		<input type="hidden" name="return" value="<?php echo $this->escape($this->return_page); ?>" />
		<input type="hidden" name="return_from" value="<?php echo base64_encode(JURI::getInstance()); ?>" />
	</form>
</div>

<?php if ($this->config->modal == 1) echo JHtml::_('bootstrap.renderModal', 'rsfRsfilesModal', array('title' => '', 'bodyHeight' => 70)); ?>
<?php echo JHtml::_('bootstrap.renderModal', 'rsfIcon', array('title' => JText::_('COM_RSFILES_SELECT_FILE_ICON'), 'bodyHeight' => 70, 'modalWidth' => 40), $this->loadTemplate('icon')) ?>