<?php
/**
* @package RSFiles!
* @copyright (C) 2010-2014 www.rsjoomla.com
* @license GPL, http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' ); ?>

<?php if (!empty($this->items)) { ?>
<?php $columns = $this->params->get('cols', 3); ?>
<?php $cols = ceil(12/$columns); ?>
<?php $items = array_chunk($this->items, $columns); ?>

<?php foreach ($items as $chunck) { ?>
<div class="<?php echo RSFilesAdapterGrid::row(); ?> mt-3">
	<?php foreach($chunck as $item) { ?>
		<?php $canDownload = rsfilesHelper::permissions('CanDownload',$item->fullpath); ?>
		<?php if (!empty($item->DownloadLimit) && $item->Downloads >= $item->DownloadLimit) $canDownload = false; ?>
		
		<div class="<?php echo RSFilesAdapterGrid::column($cols); ?> d-flex rsfiles-block-item">
			<div class="card text-center flex-fill">
				<div class="card-image">
					<i class="<?php echo $item->type != 'folder' ? $item->icon : 'fa fa-folder'; ?> rsfiles-icon-large"></i>
				</div>
				<div class="card-body">
					<?php if ($item->type != 'folder') { ?>
					<?php $download = rsfilesHelper::downloadlink($item,$item->fullpath); ?>
					<?php if ($canDownload && $this->config->direct_download) { ?>
					<?php if ($download->ismodal) { ?>
					<a class="rsfiles-file" href="javascript:void(0)" onclick="rsfiles_show_modal('<?php echo $download->dlink; ?>', '<?php echo JText::_('COM_RSFILES_DOWNLOAD'); ?>', 600)">
					<?php } else { ?>
					<a class="rsfiles-file rsfiles-download-link" href="<?php echo $download->dlink; ?>">
					<?php } ?>
					<?php } else { ?>
					<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&layout=download&path='.rsfilesHelper::encode($item->fullpath).$this->itemid); ?>" class="rsfiles-file">
					<?php } ?>
					<?php } else { ?>
					<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&folder='.rsfilesHelper::encode($item->fullpath).$this->itemid); ?>">
					<?php } ?>
						<h5 class="card-title"><?php echo !empty($item->filename) ? $item->filename : $item->name; ?></h5>
					</a>
					
					<div class="clearfix"></div>
					
					<?php if ($item->type != 'folder' && $item->isnew) { ?>
					<span class="badge badge-info bg-info"><?php echo JText::_('COM_RSFILES_NEW'); ?></span>
					<?php } ?>
					
					<?php if ($item->type != 'folder' && $item->popular) { ?>
						<span class="badge badge-success bg-success"><?php echo JText::_('COM_RSFILES_POPULAR'); ?></span>
					<?php } ?>
					
				</div>
				
				<?php if ($item->type != 'folder') { ?>
				<div class="card-footer">					
					<?php if ($canDownload && $this->config->direct_download) { ?>
					<?php if ($download->ismodal) { ?>
					<a class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_DOWNLOAD'); ?>" href="javascript:void(0)" onclick="rsfiles_show_modal('<?php echo $download->dlink; ?>', '<?php echo JText::_('COM_RSFILES_DOWNLOAD'); ?>', 600);">
					<?php } else { ?>
					<a class="hasTooltip rsfiles-download-link" title="<?php echo JText::_('COM_RSFILES_DOWNLOAD'); ?>" href="<?php echo $download->dlink; ?>">
					<?php } ?>
					<?php } else { ?>
					<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&layout=download&path='.rsfilesHelper::encode($item->fullpath).$this->itemid); ?>" class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_DOWNLOAD'); ?>">
					<?php } ?>
						<i class="fa fa-download fa-fw"></i>
					</a>
					
					<?php if ($this->config->show_details) { ?>
					<a href="<?php echo JRoute::_('index.php?option=com_rsfiles&layout=details&path='.rsfilesHelper::encode($item->fullpath).$this->itemid); ?>" class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_DETAILS'); ?>">
						<i class="fa fa-list fa-fw"></i>
					</a>
					<?php } ?>
					
					<?php if ($canDownload) { ?>
						<?php $properties	= rsfilesHelper::previewProperties($item->id, $item->fullpath); ?>
						<?php $extension	= $properties['extension']; ?>
						<?php $size			= $properties['size']; ?>
						
						<?php if (in_array($extension, rsfilesHelper::previewExtensions()) && $item->show_preview) { ?>
						<a href="javascript:void(0)" onclick="rsfiles_show_modal('<?php echo rsfilesHelper::previewURL($extension, JRoute::_('index.php?option=com_rsfiles&layout=preview&tmpl=component&path='.rsfilesHelper::encode($item->fullpath).$this->itemid)); ?>', '<?php echo JText::_('COM_RSFILES_PREVIEW'); ?>', <?php echo $size['height']; ?>, '<?php echo $properties['handler']; ?>');" class="hasTooltip" title="<?php echo JText::_('COM_RSFILES_PREVIEW'); ?>">
							<i class="fa fa-search fa-fw"></i>
						</a>
						<?php } ?>
					<?php } ?>
					
				</div>
				<?php } ?>
			</div>
		</div>
	<?php } ?>
</div>
<?php } ?>
<?php } ?>